package com.s3ai.controllers.tickets;

import com.s3ai.entities.Ticket;
import com.s3ai.services.CinemaService;
import com.s3ai.services.TicketService;
import com.s3ai.services.UserService;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Random;

public class TicketsFill extends HttpServlet {
    TicketService ticketService = TicketService.getInstance();
    UserService userService = UserService.getInstance();
    CinemaService cinemaService = CinemaService.getInstance();

    private String[] wordsFirst = new String[] {"Pirates", "Ladies", "Goblins", "Gangsters", "Programmers", "Hackers", "Wrestlers", "Animals", "Guardians"};
    private String[] wordsSecond = new String[] {"of the", "in", "from"};
    private String[] wordsThird = new String[] {"Galaxy", "America", "Russia", "Japan", "Ocean", "Deep", "Caribbean", "Matrix", "Internet", "Woods", "Caves"};

    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        var users = userService.getAllUsers();
        var cinemas = cinemaService.getAllCinemas();

        var writer = response.getWriter();
        writer.println("FILLED Instances:");
        var random = new Random();
        for (int i = 0; i < 300; i++) {
            var ticket = new Ticket();
            ticketService.fillTicketFields(ticket, users.get(random.nextInt(users.size())), cinemas.get(random.nextInt(cinemas.size())), randomMovieName());
            ticketService.saveTicket(ticket);
            writer.println(ticket);
        }
    }

    private String randomMovieName() {
        var random = new Random();
        return String.format("%s %s %s", wordsFirst[random.nextInt(wordsFirst.length)], wordsSecond[random.nextInt(wordsSecond.length)], wordsThird[random.nextInt(wordsThird.length)]);
    }
}
